/************************************************************************
 *                                                                      *
 * GLE - Graphics Layout Engine <http://glx.sourceforge.net/>          *
 *                                                                      *
 * Modified BSD License                                                 *
 *                                                                      *
 * Copyright (C) 2009 GLE.                                              *
 *                                                                      *
 * Redistribution and use in source and binary forms, with or without   *
 * modification, are permitted provided that the following conditions   *
 * are met:                                                             *
 *                                                                      *
 *    1. Redistributions of source code must retain the above copyright *
 * notice, this list of conditions and the following disclaimer.        *
 *                                                                      *
 *    2. Redistributions in binary form must reproduce the above        *
 * copyright notice, this list of conditions and the following          *
 * disclaimer in the documentation and/or other materials provided with *
 * the distribution.                                                    *
 *                                                                      *
 *    3. The name of the author may not be used to endorse or promote   *
 * products derived from this software without specific prior written   *
 * permission.                                                          *
 *                                                                      *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR   *
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED       *
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   *
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY       *
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL   *
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE    *
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS        *
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER *
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR      *
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN  *
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                        *
 *                                                                      *
 ************************************************************************/

#define GLE_KW_NB                             91

#define GLE_KW_BLANK                          0
#define GLE_KW_ABOUND                         87
#define GLE_KW_ALINE                          1
#define GLE_KW_AMOVE                          2
#define GLE_KW_ARC                            3
#define GLE_KW_ARCTO                          4
#define GLE_KW_ASETPOS                        73
#define GLE_KW_ASSIGNMENT                     51
#define GLE_KW_BEGIN                          5
#define GLE_KW_BEZIER                         6
#define GLE_KW_BIGFILE                        58
#define GLE_KW_BITMAP                         68
#define GLE_KW_BITMAP_INFO                    69
#define GLE_KW_BOX                            7
#define GLE_KW_CALL                           52
#define GLE_KW_CIRCLE                         8
#define GLE_KW_CLOSEPATH                      9
#define GLE_KW_COLORMAP                       80
#define GLE_KW_COMMENT                        53
#define GLE_KW_COMPATIBILITY                  86
#define GLE_KW_CURVE                          10
#define GLE_KW_DECLARESUB                     83
#define GLE_KW_DEFAULT                        84
#define GLE_KW_DEFCOLOR                       85
#define GLE_KW_DEFINE                         11
#define GLE_KW_DEFMARKER                      60
#define GLE_KW_DFONT                          12
#define GLE_KW_DRAW                           56
#define GLE_KW_ELLIPSE                        70
#define GLE_KW_ELLIPTICAL_ARC                 71
#define GLE_KW_ELLIPTICAL_NARC                72
#define GLE_KW_ELSE                           13
#define GLE_KW_END                            14
#define GLE_KW_FCLOSE                         15
#define GLE_KW_FGETLINE                       75
#define GLE_KW_FILL                           16
#define GLE_KW_FOPEN                          17
#define GLE_KW_FOR                            18
#define GLE_KW_FREAD                          61
#define GLE_KW_FREADLN                        62
#define GLE_KW_FTOKENIZER                     76
#define GLE_KW_FWRITE                         63
#define GLE_KW_FWRITELN                       64
#define GLE_KW_COMMENT                        53
#define GLE_KW_GOTO                           19
#define GLE_KW_GRESTORE                       54
#define GLE_KW_GSAVE                          20
#define GLE_KW_ICON                           21
#define GLE_KW_IF                             22
#define GLE_KW_INCLUDE                        23
#define GLE_KW_INPUT                          24
#define GLE_KW_JOIN                           25
#define GLE_KW_MARGINS                        78
#define GLE_KW_MARKER                         26
#define GLE_KW_MOVE                           27
#define GLE_KW_NAME                           39
#define GLE_KW_NARC                           28
#define GLE_KW_NEWPATH                        29
#define GLE_KW_NEXT                           30
#define GLE_KW_ORIENTATION                    79
#define GLE_KW_PAPERSIZE                      77
#define GLE_KW_PIE                            31
#define GLE_KW_POSTSCRIPT                     55
#define GLE_KW_PRINT                          32
#define GLE_KW_PSBBTWEAK                      66
#define GLE_KW_PSCOMMENT                      65
#define GLE_KW_RBEZIER                        33
#define GLE_KW_REGION                         34
#define GLE_KW_RESTOREDEFAULTS                82
#define GLE_KW_RETURN                         50
#define GLE_KW_REVERSE                        35
#define GLE_KW_RLINE                          36
#define GLE_KW_RMOVE                          37
#define GLE_KW_ROT                            38
#define GLE_KW_ROTATE                         38
#define GLE_KW_RSETPOS                        81
#define GLE_KW_SAVE                           39
#define GLE_KW_SCALE                          40
#define GLE_KW_SET                            41
#define GLE_KW_SET                            41
#define GLE_KW_SIZE                           42
#define GLE_KW_SLEEP                          88
#define GLE_KW_STROKE                         43
#define GLE_KW_SUB                            44
#define GLE_KW_TEX                            74
#define GLE_KW_TEXT                           45
#define GLE_KW_TEXTDEF                        59
#define GLE_KW_TIFF                           67
#define GLE_KW_TRAN                           46
#define GLE_KW_TRANSLATE                      46
#define GLE_KW_UNTIL                          47
#define GLE_KW_WHILE                          48
#define GLE_KW_WRITE                          49
#define GLE_KW_BLOCK_COMMAND                  89
#define GLE_KW_SWAP							  90
